package swanky.regex;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.util.regex.*;

/**
 * Modified by JavaCookbook REDemo.java
 * 
 * @author Hsiao Yu Cheng
 * @version 1.00, 09/09/04
 */
public class RETest extends JApplet{
   protected Pattern pattern;
   protected Matcher matcher;
   protected JTextField patternTF, stringTF;
   protected JCheckBox compiledOK;
   protected JRadioButton match, find, findAll, split;
   protected JTextField matchesTF;
   protected JPanel panel = new JPanel();
   protected JTextArea logTextArea = new JTextArea(10, 40);

   public void init(){
      RETest comp = new RETest();
      getContentPane().add(comp.panel, BorderLayout.NORTH);
      JScrollPane scrollPane = new JScrollPane(comp.logTextArea);
      getContentPane().add(scrollPane, BorderLayout.CENTER);
   }

   /** "main program" method - construct and show */
   public static void main(String[] av){
      JFrame f = new JFrame("RE Test");
      f.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
      RETest comp = new RETest();
      f.getContentPane().add(comp.panel, BorderLayout.NORTH);
      JScrollPane scrollPane = new JScrollPane(comp.logTextArea);
      f.getContentPane().add(scrollPane, BorderLayout.CENTER);
      f.pack();
      f.setLocation(200, 200);
      f.setVisible(true);
   }

   /** Construct the REDemo object including its GUI */
   public RETest(){
      super();

      //top
      JPanel top = new JPanel();
      top.add(new JLabel("Pattern:", JLabel.RIGHT));
      patternTF = new JTextField(20);
      patternTF.getDocument().addDocumentListener(new PatternListener());
      top.add(patternTF);
      top.add(new JLabel("Syntax OK?"));
      compiledOK = new JCheckBox();
      compiledOK.setEnabled(false);
      top.add(compiledOK);

      //strPane
      JPanel strPane = new JPanel();
      strPane.add(new JLabel("String:", JLabel.RIGHT));
      stringTF = new JTextField(20);
      stringTF.getDocument().addDocumentListener(new StringListener());
      strPane.add(stringTF);
      strPane.add(new JLabel("Matches:"));
      matchesTF = new JTextField(3);
      matchesTF.setEditable(false);
      strPane.add(matchesTF);

      //switchPane
      ChangeListener cl = new ChangeListener(){
         public void stateChanged(ChangeEvent ce){
            tryMatch();
         }
      };
      JPanel switchPane = new JPanel();
      ButtonGroup bg = new ButtonGroup();
      match = new JRadioButton("Match");
      match.setSelected(true);
      match.addChangeListener(cl);
      bg.add(match);
      switchPane.add(match);
      find = new JRadioButton("Find");
      find.addChangeListener(cl);
      bg.add(find);
      switchPane.add(find);
      findAll = new JRadioButton("Find All");
      findAll.addChangeListener(cl);
      bg.add(findAll);
      switchPane.add(findAll);
      split = new JRadioButton("Split");
      split.addChangeListener(cl);
      bg.add(split);
      switchPane.add(split);
      JButton showRECode = new JButton("RE Code");
      showRECode.addActionListener(new ActionListener(){
         public void actionPerformed(ActionEvent e){
            String output = convert(patternTF.getText());
            JOptionPane.showMessageDialog(RETest.this.panel, new JTextField(
                  output), "RE Code", JOptionPane.INFORMATION_MESSAGE);
         }
      });
      switchPane.add(showRECode);

      //put components on content pane
      panel.setLayout(new BorderLayout());
      panel.add(top, BorderLayout.NORTH);
      panel.add(strPane, BorderLayout.CENTER);
      panel.add(switchPane, BorderLayout.SOUTH);
   }

   /**
    * ]w matchesTF r (Yes or No)
    * 
    * @param b
    *           O_ match
    */
   protected void setMatches(boolean b){
      if(b)
         matchesTF.setText("Yes");
      else
         matchesTF.setText("No");
   }

   /**
    * ]w matchesTF r (Ʀr)
    * 
    * @param n
    *           match X
    */
   protected void setMatches(int n){
      matchesTF.setText(Integer.toString(n));
   }

   /**  patternTF rإ patternAó]w compiledOK A */
   protected void tryCompile(){
      pattern = null;
      try{
         pattern = Pattern.compile(patternTF.getText());
         matcher = pattern.matcher("");
         compiledOK.setSelected(true);
      }
      catch(PatternSyntaxException ex){
         compiledOK.setSelected(false);
      }
   }

   /** AܵG */
   protected boolean tryMatch(){
      logTextArea.setText("");
      if(pattern == null){
         return false;
      }
      matcher.reset(stringTF.getText());
      if(match.isSelected() && matcher.matches()){
         setMatches(true);
         logTextArea.setText(matcher.group());
         return true;
      }
      if(find.isSelected() && matcher.find()){
         setMatches(true);
         logTextArea.setText(matcher.group());
         return true;
      }
      if(findAll.isSelected()){
         int i = 0;
         while (matcher.find()){
            ++i;
            logTextArea.append(i + ": " + matcher.group() + "\n");
         }
         if(i > 0){
            setMatches(i);
            return true;
         }
      }
      if(split.isSelected()){
         String[] stringArray = pattern.split(stringTF.getText());
         setMatches(stringArray.length);
         for(int i = 0; i < stringArray.length; i++){
            logTextArea.append((i + 1) + ": " + stringArray[i] + "\n");
         }
         return true;
      }
      setMatches(false);
      return false;
   }

   /**
    * ] \ P " rb java rHεrꪺNq <br />
    * ҥHഫ \\ H \"
    * 
    * @param reString
    *           J Regular Expression ˦
    * @return java lXir
    */
   public String convert(String reString){
      StringBuilder javaString = new StringBuilder();
      for(int i = 0; i < reString.length(); i++){
         char c = reString.charAt(i);
         switch(c){
            case '\\':
            case '"':
               javaString.append("\\");
            default:
               javaString.append(c);
         }
      }
      return javaString.toString();
   }

   /** Any change to the pattern tries to compile the result. */
   class PatternListener implements DocumentListener{

      public void changedUpdate(DocumentEvent ev){
         tryCompile();
         tryMatch();
      }

      public void insertUpdate(DocumentEvent ev){
         tryCompile();
         tryMatch();
      }

      public void removeUpdate(DocumentEvent ev){
         tryCompile();
         tryMatch();
      }
   }

   /** Any change to the input string tries to match the result */
   class StringListener implements DocumentListener{

      public void changedUpdate(DocumentEvent ev){
         tryMatch();
      }

      public void insertUpdate(DocumentEvent ev){
         tryMatch();
      }

      public void removeUpdate(DocumentEvent ev){
         tryMatch();
      }
   }
}